// The Global Sidebar Object

window.addEventListener("load",OnLoadSpurlOverlay,false);

var SpurlPref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('spurlbar.settings.');
var SpurlBaseUrl = 'http://www.spurl.net/spurl.php';
var SpurlPopupOptions = 'width=450,height=600,status=no,resizable=yes,scrollbars=auto';

function hash (hashtext) {
  if (hashtext == "") return 0;
  var i = hashtext.length;
  var index = 0;
  var hashnumber = 0;
  for (index =0; index < i; index++) {
    hashnumber += index * hashtext.charCodeAt(index);
  }
  return hashnumber;
}

function OnLoadSpurlOverlay() {
	if (document.getElementById("contentAreaContextMenu")) {
		top.document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",OnContentPopup,false);
  	}
	if (SpurlPref.prefHasUserValue('spurl_bookmarks')) {
			top.document.getElementById("popupspurlItbookmarks").hidden = !SpurlPref.getBoolPref ('spurl_bookmarks');
	}
	var spurlbarDescription = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch('extensions.{e462bd40-d91b-4d7b-a1db-874c448c4fff}.');
	var spurlDescription = top.document.getElementById("spurl_stringBundle").getString("description");
	var str = Components.classes["@mozilla.org/supports-string;1" ].createInstance(Components.interfaces.nsISupportsString );
	str.data = spurlDescription;
	spurlbarDescription.setComplexValue("description",Components.interfaces.nsISupportsString, str);
}

function OnContentPopup () {

	var elem = document.popupNode,node = document.popupNode;
	var item1=top.document.getElementById("popupspurlItpage");
	var item2=top.document.getElementById("popupspurlItlink");
	var item3=top.document.getElementById("popupspurlItframe");
	var item4=top.document.getElementById("popupspurlItbookmarks");
	var item5=top.document.getElementById("popupspurlaspage");
	var localname = document.popupNode.localName.toUpperCase();
	var onLink=false;
		/* Copied from browser.js */
	if ( localname == "IMG" ) {
		// Look for image map.
		var mapName = elem.getAttribute( "usemap" );
		if ( mapName ) {
			// Find map.
			var map = elem.ownerDocument.getElementById( mapName.substr(1) );
			if ( map ) {
				// Search child <area>s for a match.
				var areas = map.childNodes;
				//XXX Client side image maps are too hard for now!
				areas.length = 0;
				for ( var i = 0; i < areas.length && !onLink; i++ ) {
					var area = areas[i];
					if ( area.nodeType == Node.ELEMENT_NODE
						 &&
						 area.localName.toUpperCase() == "AREA" ) {
						// Get type (rect/circle/polygon/default).
						var type = area.getAttribute( "type" );
						switch ( type.toUpperCase() ) {
							case "RECT":
							case "RECTANGLE":
								break;
							case "CIRC":
							case "CIRCLE":
								break;
							case "POLY":
							case "POLYGON":
								break;
							case "DEFAULT":
								// Default matches entire image.
								onLink = true;
								break;
						}
					}
				}
			}
		}
	}
	/* Search through to first node */
	while ( elem ) {
 		if ( elem.nodeType == Node.ELEMENT_NODE ) {
        	localname = elem.localName.toUpperCase();
			if ( (localname === "A" && elem.href) ||
                  localname === "AREA" ||
                  localname === "LINK" ||
                  elem.getAttributeNS( "http://www.w3.org/1999/xlink", "type") == "simple" )  { 
				onLink = true;
			}
		}
		elem = elem.parentNode;
	}
	
	if (!onLink) {	  
		if (SpurlPref.prefHasUserValue('spurl_page') && SpurlPref.prefHasUserValue('spurlas_page')) {
			item1.hidden = !SpurlPref.getBoolPref ('spurl_page');
			item5.hidden = !SpurlPref.getBoolPref ('spurlas_page');
		} else {
			item1.hidden = false;
			item5.hidden = false;
		}
		item2.hidden=true;
	} else { 
		if (SpurlPref.prefHasUserValue('spurl_link')) {
			item2.hidden = !SpurlPref.getBoolPref ('spurl_link');
		} else {
			item2.hidden=false;
		}
		item1.hidden=true;
		item5.hidden=true;
	}
	// check if popup is in frame
	if (node.ownerDocument != window._content.document) {   
		if (SpurlPref.prefHasUserValue('spurl_frame')) {
			item3.hidden = !SpurlPref.getBoolPref ('spurl_frame');
		} else {
			item3.hidden = false;
		}
	} else { 
		item3.hidden = true; 
	}
}

function popupspurlIt (mode) {
	if (mode == 1) {  // spurl the current page
		spurlIt();
	}
	if (mode == 2) { // spurl the link
		var node = top.document.popupNode;
    	var surl = node.href;
		var url=SpurlBaseUrl+'?v=4&title=&url=';
		url=url.concat(encodeURIComponent(surl));
		window.open(url,'_blank',SpurlPopupOptions);
	}
	if (mode == 3) {  // spurl the frame link
		var surl= top.document.popupNode.ownerDocument.location.href;
		var url=SpurlBaseUrl+'?v=4&title=&url=';
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var blocked=focusedWindow.getSelection().toString();
		url=url.concat(encodeURIComponent(surl));
		url=url.concat('&blocked=');
		url=url.concat(encodeURIComponent(blocked));
		window.open(url,'_blank',SpurlPopupOptions);
	}
}
function spurlas (mode) {
	if (mode == 1) { // spurl as the current page
		var href=window.top._content.document.location.href;
		var title=window.top._content.document.title;
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var stringBundle = document.getElementById("spurl_stringBundle");
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var blocked=focusedWindow.getSelection().toString();
		var url=SpurlBaseUrl+'?v=4&title=';
		var newurl={
			value: href};
		if (!promptService.prompt(window,stringBundle.getString("title_url"),stringBundle.getString("text_url"),newurl,null,{}))
		return;
		
		url=url.concat(encodeURIComponent(title));
		url=url.concat('&url=');
		url=url.concat(encodeURIComponent(newurl.value));
		url=url.concat('&blocked=');
		url=url.concat(encodeURIComponent(blocked));
		window.open(url,'_blank',SpurlPopupOptions);	
	}
}
		
		
function spurlIt () {
	
		var title=window.top._content.document.title;
		var href=window.top._content.document.location.href;
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var blocked=focusedWindow.getSelection().toString();
		var url=SpurlBaseUrl+'?v=4&title=';
			
		url=url.concat(title);
		url=url.concat('&url=');
		url=url.concat(encodeURIComponent(href));
		url=url.concat('&blocked=');
		url=url.concat(encodeURIComponent(blocked));
		window.open(url,'_blank',SpurlPopupOptions);
}

function spurlURL (remote_url) {
	
		var href=remote_url;
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var blocked=focusedWindow.getSelection().toString();
		var url=SpurlBaseUrl+'?v=4&title=';
		url=url.concat('&url=');
		url=url.concat(encodeURIComponent(href));
		url=url.concat('&blocked=');
		url=url.concat(encodeURIComponent(blocked));
		window.open(url,'_blank',SpurlPopupOptions);
}

var dragObserver = {
	getSupportedFlavours: function () {
		var flavours = new FlavourSet ();
		flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},
	onDragOver: function(evt,flavour,session) {},
	onDrop: function (evt,dropdata,session) {
		if (dropdata != "") {
			var url = transferUtils.retrieveURLFromData(dropdata.data, dropdata.flavour.contentType);
			spurlURL(url);
		}
	}
}
